% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RemoteTask.R
\name{RemoteTask}
\alias{RemoteTask}
\title{RemoteTask class}
\format{
RemoteTask \link{R6Class} object.
}
\usage{
# Connect to remote sensing database.
remotesensing <- RemoteSensing$new(url, userpwd=NULL)

# Run a remote task at RSDB server.
remote_task <- remotesensing$submit_task(task)

# Get current task status information.
status <- remote_task$status

# Wait until task has finished processing, check task status every polling_interval seconds.
status <- remote_task$wait(polling_interval = 0.5)
}
\description{
RemoteTask class provides methods to manage a remote task running at RSDB server.
}
\examples{

remotesensing <- RSDB::RemoteSensing$new('http://localhost:8080', userpwd='user:password')

task <- list(task_rasterdb = 'count_pixels', rasterdb = 'raster1')

remote_task <- remotesensing$submit_task(task)

status <- remote_task$wait()

status$message

}
\seealso{
\link{RemoteSensing}
}
\author{
woellauer
}
\keyword{remote}
\keyword{task}
\section{Methods}{
\subsection{Public methods}{
\itemize{
\item \href{#method-RemoteTask-new}{\code{RemoteTask$new()}}
\item \href{#method-RemoteTask-wait}{\code{RemoteTask$wait()}}
}
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-RemoteTask-new"></a>}}
\if{latex}{\out{\hypertarget{method-RemoteTask-new}{}}}
\subsection{Method \code{new()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{RemoteTask$new(rsdbConnector, id)}\if{html}{\out{</div>}}
}

}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-RemoteTask-wait"></a>}}
\if{latex}{\out{\hypertarget{method-RemoteTask-wait}{}}}
\subsection{Method \code{wait()}}{
\subsection{Usage}{
\if{html}{\out{<div class="r">}}\preformatted{RemoteTask$wait(polling_interval = 0.5)}\if{html}{\out{</div>}}
}

}
}
