package util.tiff;

import java.io.DataOutput;
import java.io.IOException;

public abstract class TiffBandUint8ofInt32Byte2 extends TiffBandUint8ofInt32 {

	public TiffBandUint8ofInt32Byte2(int width, int height, String description) {
		super(width, height, description);
	}
	
	@Override
	public void writeData(DataOutput out) throws IOException {
		int[] data = getData();
		int w = width;
		int h = height;
		int len = w*h;
		if(data.length != len) {
			throw new RuntimeException();
		}
		byte[] target = new byte[len];
		for(int i = (len - 1); i >= 0; i--) {
			target[i] = (byte) (0xff & (data[i] >> 16));
		}
		out.write(target);
	}	
}
