package voxeldb.aggregatedprocessor.base;

import util.Range3d;
import voxeldb.CellFactory;
import voxeldb.VoxelCell;
import voxeldb.VoxelGeoRef;

public class AggProcFloat32Delegate2 extends AggProcFloat32 {

	protected final AggProcFloat32 aggProcA;
	protected final AggProcFloat32 aggProcB;

	public AggProcFloat32Delegate2(CellFactory cellFactory, Range3d range, int aggregation_factor_x, int aggregation_factor_y, int aggregation_factor_z, VoxelGeoRef aggRef, AggProcFloat32 aggProcA, AggProcFloat32 aggProcB) {
		super(cellFactory, range, aggregation_factor_x, aggregation_factor_y, aggregation_factor_z, aggRef);
		this.aggProcA = aggProcA;
		this.aggProcB = aggProcB;
	}

	@Override
	public void process(VoxelCell voxelCell, int xSrcStart, int ySrcStart, int zSrcStart, int xSrcEnd, int ySrcEnd,
			int zSrcEnd, int xSrcDstOffset, int ySrcDstOffset, int zSrcDstOffset) {
		aggProcA.process(voxelCell, xSrcStart, ySrcStart, zSrcStart, xSrcEnd, ySrcEnd, zSrcEnd, xSrcDstOffset, ySrcDstOffset, zSrcDstOffset);
		aggProcB.process(voxelCell, xSrcStart, ySrcStart, zSrcStart, xSrcEnd, ySrcEnd, zSrcEnd, xSrcDstOffset, ySrcDstOffset, zSrcDstOffset);
	}
}
